import 'asis.dart';

extension FutureDynamicExtension on Future<dynamic> {
  /// Transforms this element to specified [Type] by applying the transformation
  /// function.
  Future<T> as<T>(T f(e)) async => f((await this));

  /// Cast as a dynamic [List].
  Future<List> get asList async => (await this) as List;

  /// Cast as a [List] of [Type] by applying the transformation function.
  Future<List<T>> asListOf<T>(T f(e)) => asList.as<T>(f);
}
