extension FutureListExtension on Future<List> {
  /// [List.map] equivalent of [Future<List>].
  Future<Iterable<T>> map<T>(T f(e)) async => (await this).map(f);

  /// Transforms each element of this [List] to a [List] of specified [Type] by
  /// applying the transformation function.
  Future<List<T>> as<T>(T f(e)) async => (await map<T>(f)).toList();
}
