import 'package:http/http.dart';
import 'asis.dart';

extension FutureResponseExtension on Future<Response> {
  /// Returns the decoded [Response.body] as a [Future].
  Future<dynamic> get json async => (await this).json;

  /// Returns the decoded [Response.body] as a [Future] of [Type].
  Future<T> as<T>(T f(e)) => json.as<T>(f);

  /// Returns the decoded [Response.body] as s [Future] of a dynamic [List].
  Future<List> get asList => json.asList;

  /// Returns the decoded [Response.body] as a [Future] of a [List] of [Type].
  Future<List<T>> asListOf<T>(T f(e)) => json.asListOf<T>(f);
}
